<?php
require_once dirname(dirname(__FILE__),2). '/classes/dateTimeService.php';
require_once dirname(dirname(__FILE__),2) . '/LobbyPOS/classes/posDbServices.php';

use lobbypos\posDbServices as PosDbServiceL;

class posCart
{
    private $posCartID;
    private $posItemsID;
    private $posUserID;
    private $posTerminalID;
    private $posCartTimeStamp;

    public function getPosCartID()
    {
        return $this->posCartID;
    }

    public function setPosCartID($posCartID): void
    {
        $this->posCartID = $posCartID;
    }

    public function getPosItemsID()
    {
        return $this->posItemsID;
    }

    public function setPosItemsID($posItemsID): void
    {
        $this->posItemsID = $posItemsID;
    }

    public function getPosUserID()
    {
        return $this->posUserID;
    }

    public function setPosUserID($posUserID): void
    {
        $this->posUserID = $posUserID;
    }

    public function getPosTerminalID()
    {
        return $this->posTerminalID;
    }

    public function setPosTerminalID($posTerminalID): void
    {
        $this->posTerminalID = $posTerminalID;
    }

    public function getPosCartTimeStamp()
    {
        return $this->posCartTimeStamp;
    }

    public function setPosCartTimeStamp($posCartTimeStamp): void
    {
        $this->posCartTimeStamp = $posCartTimeStamp;
    }


    function addItemToCart(){

        $db = new PosDbServiceL();
        $conC = $db->dbConnect();
        $dt = new dateTimeService();
        $timeStamp = $dt->createCurrentTimeStamp();
        if(isset($_SESSION['userID'])) {
            $userID = $_SESSION['userID'];
        }else {
            $userID = 0;
        }

        //terminalID
        if(isset($_SESSION['terminalID'])) {
            $terminalID = $_SESSION['terminalID'];
        }else {
            $terminalID = 0;
        }

        if($conC != null){

            //echo '<script>alert(" fee '.$feeName.' desc '.$feeDescription.' Display '.$feeCode.' start '.$feeStartDate.' end '.$feeEndDate.' amount '.$feeAmount.' type '. $feeType.' status '.$feeStatusID.' created '.$feeCreatedBy.'")</script>';
            $createCust = $conC->prepare("INSERT INTO posCart VALUES (null,?,?,?,?)");
            if($createCust == false) {
                return ' Insert Cart Status error ' . mysqli_error($conC);
            }
            $createCust->bind_param("iiss",  $this->posItemsID, $userID, $terminalID, $timeStamp);
            if($createCust->execute() == false) {
                return ' Insert Cart Status error ' . mysqli_error($conC);
            }
            $this->terminalPurchasesId = $createCust->insert_id;

        }
        $conC = null;
        $createCust->close();
        return true;


    }

    function listCartItems(){

        $db = new PosDbServiceL();
        $conS = $db->dbConnect();
        $itemCount = 0;
        $cartTotal = 0;
        if ($conS != null) {

            if(isset($_SESSION['userID'])) {
                $userID = $_SESSION['userID'];
            }else {
                $userID = 0;
            }

            //SELECT NUM, count(*) as 'Cnt' FROM Table1 GROUP BY NUM
            $resultS = $conS->query("SELECT GROUP_CONCAT(posCart.posCartID) as pIID, posItems.posItemsID, posItems.posItemsName, SUM(posItems.posItemsPrice) as tPrice, COUNT(posCart.posItemsID) AS QTY FROM posCart JOIN posItems ON posCart.posItemsID = posItems.posItemsID WHERE posUserID = $userID GROUP BY posItems.posItemsID, posItems.posItemsName, posItems.posItemsDescription, posItems.posItemsPrice");
            if($resultS){
                //1 coke -> $100
                echo '<table class="posItemsTable">';

                    while ($n = $resultS->fetch_assoc()) {
                        echo '<tr>';
                        $itemCount++;
                        echo '<td>';
                            $cartTotal += intval($n['tPrice']);
                            $itemPrice = '$'.number_format(floatval(trim($n['tPrice']/100)),2);
                            echo '<span class="itemFont">'.$n['QTY'].' '. $n['posItemsName']. ' -> '.$itemPrice . ' '.'</span>';
                            echo '<form method="post" action="#" target="" style="display: inline-block">';
                            echo '<input type="hidden" name="posCartID" value="'.$n['pIID'].'">';
                            echo '<input type="submit" name="deleteItem" class="deleteSeatsDash" value="-">';
;                           echo '</form>';
                        echo '</td>';
                        echo '</tr>';
                    }
                    if($itemCount == 0){
                        echo '<h2>No Items Selected</h2>';
                    }
                    $convertGrandTotal = '$'.number_format(floatval(trim($cartTotal/100)),2);
                    echo '<script>window.top.document.getElementById("totalBox").value = "'.$convertGrandTotal.'"</script>';
                    echo '<script>window.top.document.getElementById("amount").value = "'.$convertGrandTotal.'"</script>';
                    echo '<script>window.top.document.getElementById("cashAmount").value = "'.$cartTotal.'"</script>';
                    $resultS->close();

                echo '</table>';
            }
        }

        $conS = null;
        return '';
    }

    function removeItemFromCart($posCartID){

        $db = new PosDbServiceL();
        $conD = $db->dbConnect();

        $remove = $conD->prepare("DELETE FROM posCart WHERE posCartID = ?");
        if ($remove === false) {
            return ' Delete a cart item error ' . mysqli_error($conD);
        }
        $remove->bind_param("i",$posCartID);

        if ($remove->execute() === false) {
            return ' Delete a cart item error ' . mysqli_error($conD);
        }

        $conD = null;
        $remove->close();
        return 'Cart Item removed successfuly';

    }

    function removeItemFromCartByUser($userID){

        $db = new PosDbServiceL();
        $conD = $db->dbConnect();

        $remove = $conD->prepare("DELETE FROM posCart WHERE posUserID = ?");
        if ($remove === false) {
            return ' Delete a cart item error ' . mysqli_error($conD);
        }
        $remove->bind_param("i",$userID);

        if ($remove->execute() === false) {
            return ' Delete a cart item error ' . mysqli_error($conD);
        }

        $conD = null;
        $remove->close();
        return 'Cart Item removed successfuly';

    }

    function findPurchasedItemsByUser($userID){

        $db = new PosDbServiceL();
        $conS = $db->dbConnect();
        $posItemsIDs = Array();
        if ($conS != null) {
            if($userID == ''){
                $userID = 0;
            }

            //SELECT NUM, count(*) as 'Cnt' FROM Table1 GROUP BY NUM
            $resultS = $conS->query("SELECT posItemsID FROM posCart WHERE posUserID = $userID");
            if($resultS){
                while ($n = $resultS->fetch_assoc()) {
                   $posItemsIDs[] = $n['posItemsID'];
                }
            }
        }
        $conS = null;
        return $posItemsIDs;
    }
}