<?php

class uploads
{

    private $maxFileSize = 30 * 1024 * 1024; // 30 MB
    private $allowedImageTypes = ['image/jpeg', 'image/png', 'image/gif'];
    private $allowedVideoTypes = ['video/mp4', 'video/quicktime'];
    private $uploadDir = '../images/';
    private $uploadFile = '';

    public function getMaxFileSize(): float|int
    {
        return $this->maxFileSize;
    }

    public function setMaxFileSize(float|int $maxFileSize): void
    {
        $this->maxFileSize = $maxFileSize;
    }

    public function getAllowedImageTypes(): array
    {
        return $this->allowedImageTypes;
    }

    public function setAllowedImageTypes(array $allowedImageTypes): void
    {
        $this->allowedImageTypes = $allowedImageTypes;
    }

    public function getAllowedVideoTypes(): array
    {
        return $this->allowedVideoTypes;
    }

    public function setAllowedVideoTypes(array $allowedVideoTypes): void
    {
        $this->allowedVideoTypes = $allowedVideoTypes;
    }

    public function getUploadDir()
    {
        return $this->uploadDir;
    }

    public function setUploadDir($uploadDir): void
    {
        $this->uploadDir = $uploadDir;
    }

    public function getUploadFile(): string
    {
        return $this->uploadFile;
    }

    public function setUploadFile(string $uploadFile): void
    {
        $this->uploadFile = $uploadFile;
    }


    function createFileUpload($inputName){
        echo '<div id="upload-container">';
            echo '<input class="fileUpload" type="file" id="'.$inputName.'" name="'.$inputName.'" accept="image/*,video/*" onchange="">';
                echo '<img style="display: none" alt="Image Preview" src="" id="imagePreview'.$inputName.'" width=200px height 200px>';
                echo '<div class="progress-container" id="progress-container'.$inputName.'">';
                    echo '<div class="progress" id="progress-bar'.$inputName.'">0%</div>';
                echo '</div>';
        echo '</div>';
        echo '<script>setUploadListeners("'.$inputName.'")</script>';
    }

    function imageUpload($files)
    {

//        echo '<h3> file object ??</h3>';
//        print_r($files);
        // echo $files['file']['error'];
        if(isset($files['error'])){

            if ($files['error'] === UPLOAD_ERR_OK) {

                    if (!file_exists($this->getUploadDir())) {
                        mkdir($this->getUploadDir(), 0777, true);
                    }

                    $this->setUploadFile($this->getUploadDir() . basename($files['name']));

                    // Check the file type
                    //$fileType = mime_content_type($files['file']['tmp_name']);
                    //echo '<br> file name??? ' . $files['name']. '<br>';
                    $fileExtension = pathinfo($files['name'], PATHINFO_EXTENSION);

                    // Define an array of allowed file extensions for images and videos
                    $allowedExtensions = ['jpg', 'jpeg', 'png', 'gif', 'mp4', 'mov'];

                    //echo '<br> file exetnsion ' . $fileExtension .'<br>';
                    if (in_array(strtolower($fileExtension), $allowedExtensions)) {
                        // Check the file size
                        if ($files['size'] <= $this->getMaxFileSize()) {
                            if (move_uploaded_file($files['tmp_name'], $this->getUploadFile())) {
                                //echo "File is valid and was successfully uploaded." . $this->getUploadFile();
                                return "Complete";
                            } else {
                                return "File upload failed. " .$this->uploadErrors($files['error']) ;
                            }
                        } else {
                            return "File size exceeds the maximum allowed size ({$this->getMaxFileSize()} bytes).";
                        }
                    } else {
                        return "Invalid file type. Only images (JPG, JPEG, PNG, GIF) and videos (MP4, QuickTime) are allowed.";
                    }
                } else {
                    return "File upload failed with error code: " . $this->uploadErrors($files['error']);
                }
        }
        return 'No Image to upload';
    }

    function uploadErrors($error){
        $phpFileUploadErrors = array(
            0 => 'There is no error, the file uploaded with success',
            1 => 'The uploaded file exceeds the upload_max_filesize directive in php.ini',
            2 => 'The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form',
            3 => 'The uploaded file was only partially uploaded',
            4 => 'No file was uploaded',
            6 => 'Missing a temporary folder',
            7 => 'Failed to write file to disk.',
            8 => 'A PHP extension stopped the file upload.',
        );
        return $phpFileUploadErrors[$error];
    }
}